//---------------------------------------------------
// module  : FilteredRetroProjection.h                         
// auteur  : Max Mignotte                            
// date    :                                              
// langage : C++                                      
// labo    :                                 
//---------------------------------------------------
// 

#ifndef FILTEREDRETROPROJECTION_H
#define FILTEREDRETROPROJECTION_H

//-----------------------------------------------
// FICHIERS INCLUS ------------------------------
//-----------------------------------------------
#include <stdio.h>

#include "Function.h"

//------------------------------------------------
// DEFINITIONS -----------------------------------
//------------------------------------------------

//------------------------------------------------
// CLASSE FILTEREDRETROPROJECTION  ---------------
//------------------------------------------------
class FilteredRetroProjection 
{
 //-- Donnees --
 //-------------
 public:

   //Matrices
   float**  mat_img;
   float**  mat_tmp1;
   float**  mat_reconst;

   float**  Mat1;
   float**  Mat2;
   float**  Mat3; 

   float**  mat_radon;
   float**  mat_radon_visu;

   float**  mat_radonRFFT;
   float**  mat_radonIFFT;
   float**  mat_radonMFFT;
   float**  mat_radonRFFTFiltered;
   float**  mat_radonIFFTFiltered;
   float**  mat_radonMFFTFiltered; 

   float**  MPR;
   float**  MPI;
   float**  MPM;
   
   int width,length;
   int size;

   int width_radon,length_radon;
   int nbslices;

   //Vecteurs
   float*  VctR;
   float*  VctI;
   float*  VctM;

   //Donnees
   float MoyImg;

   //Flag
   int FlagWithoutRecalMoy;
   int FlagWithoutRecalMoy2;
   int FlagWithoutRecal;

   //Filtrage
   int   Filtrage;
   float Alpha;
        
  //-- Methodes --
  //--------------
  public:
   FilteredRetroProjection(int,int,int);
   ~FilteredRetroProjection();

  //Fonctions Client
   void Reconstruction(float**,float**);

   //Options
   void Options(float**);

   //Utile 
   void rotation(float**,float**,int,int,float);  
};

#endif 
