//------------------------------------------------------
// module  : DCT.h
// auteur  : Mignotte Max
// date    : 
// version : 1.0
// langage : C++
// labo    : DIRO
// note    : 
//------------------------------------------------------
// doit etre utilis (i.e inclus) par tous les prog. ecrit en C++
// utilisant la classe DCT ou une de ses classes drive
// les fonctions correspondantes  cette classe sont defini 
// dans f_DCT.cc

#ifndef DCT_H
#define DCT_H

//------------------------------------------------
// FICHIERS INCLUS -------------------------------
//------------------------------------------------
#include "Function.h"

//------------------------------------------------
// CLASSE DCT  -----------------------------------
//------------------------------------------------
class DCT
 { 
 //---------- Donnees ---------
 //----------------------------
  public: 

  float**     SquWin;
  float***    mat3d;

  //>Img
  int  length,width;

  //>Param
  int   size;
  int   overlap;

  //>Flag
  int FlagSilent;
     
 //--- Fonctions --------
 //----------------------
  public:  
  DCT(int,int,int);
  DCT(int,int);
   ~DCT(); 
  
   //--------------
   //Filtrage DCT 
   //--------------
   //>Filtering local 8x8
   void FilteringDCT8x8_(float**,float,int);
   void FilteringDCT8x8rs_(float**,float,int);
   void FilteringDCT8x8st_(float**,float,int);

   //>Threshold DCT
   void HardThreshold(float,float**,int);
   void SoftThreshold2(float,float**,int);

   //>Fast DCT 8x8 
   void ddct8x8s(int,float**);

   //Gestion
   float  MeanSqWindow(float**,int);
};
//---------------------------------------------

#endif
